天天问 发表于 2022-8-14 18:33:49

czb203 发表于 2022-8-14 10:28
类似这样的,能够延伸到坡脚的线

这种样式的示坡线我倒是用不着,你可以自己在源码的基础上改改,就能实现了。不过看CASS的这种示坡线,出现了交叉的时候要截断,情况比我发的这个要复杂多了。

song宋_74729 发表于 2022-8-28 09:16:14

czb203 发表于 2022-8-14 10:28
类似这样的,能够延伸到坡脚的线

画示坡线,短线长可默认,画在那一侧按光标位置

(defun c:spx ( / str ob p1 p2 p3 fx)

(while(setq ob(entsel “\n选择线:”))

(setq p1(cadr ob) ob(car ob))

(if(wcmatch (cdr(assoc 0(entget ob)))”*POLYLINE,LINE,SPLINE,CIRCLE,ARC,ELLIPSE”)

(progn

(setq ob(vlax-ename->vla-object ob))

(setq p1(vlax-curve-getclosestpointto ob p1))

(princ “\n光标位为示坡线方向”)

(setq str “\n指定短线长”)

(if spxdist (setq str(strcat str “<“(rtos spxdist) “>:”)))

(while(cond

((and (setq p3(getpoint p1 str))(> (setq d(distance p1 p3))0))

(setq spxdist d)nil

)

(spxdist(setq p3(polar p1(angle p1(cadr(grread ‘(2 13)))) spxdist))nil)

;获取当前光标坐标(cadr(grread ‘(2 13)))或(cadr(grread T 15 0))

(t)

));可使用默认短线长度spxdist

(setq p2(vlax-curve-getPointAtDist ob (+ spxdist(vlax-curve-getDistAtPoint ob p1))))

(setq fx(- (angle p2 p3)(angle p1 p2)))

(shipoxian ob spxdist (not(or(and(< fx 0)(> fx (- 0 pi)))(> fx pi))))

)

)

)

)

song宋_74729 发表于 2022-9-1 10:11:50

本帖最后由 song宋_74729 于 2022-9-1 10:21 编辑

源码分享,取之明经,用之明经

101345 发表于 2022-9-6 09:58:42

命令是多少啊?加载进去没有看到命令

天天问 发表于 2022-9-7 11:20:29

101345 发表于 2022-9-6 09:58
命令是多少啊?加载进去没有看到命令

分2个命令执行,spx1和spx2
页: 1 [2]
查看完整版本: 也发一个画示坡线的lsp【源码】